[0.19.0, 2025-12-31]:

- changed dependency on `ruamel.yaml.clib` to `ruamel.yaml.clibz`
  which includes support for free-threading (revisited after a bug
  report by [Ahmed Moustafa](https://sourceforge.net/u/aemous/profile/) and 
  some insistance by [Nathan Goldbaum](https://sourceforge.net/u/ngoldbaum/profile/)  
- added `.max_depth` to `YAML()` instance. If set to a (positive) number
  this limits the recursion, so loading does throw a `MaxDepthExceededError`.
  Based on comments by Benjamin Oberdorfer via email. This also triggered the
  new documenation section on processing unchecked input.

[0.18.17, 2025-12-17]:
- try to load C functions from `_ruamel_yaml_clibz` first.

[0.18.16, 2025-10-22]:
- root level block style scalars that started with a directives-end marker or a 
  document-end marker, are now indented 2 spaces.
- merged fix for accessing end_marks on Tokens provided by 
  [Toknak](https://sourceforge.net/u/taknok/)

[0.18.15, 2025-08-19]:
- duplicate merge keys are never allowed (not even with .allow_duplicate_keys = 
  True
- merge keys now keep there position if a key before the merge key gets deleted 
  (previously a key after the merge key would move before it)

[0.18.14, 2025-06-09]:
- Fix issue with constructing dataclasses that have a default factoryi 
  attribute, but were missing a mapping value for that attribute. Reported by 
  [Victor Prieto](https://sourceforge.net/u/vsprieto/profile/)
- the tagged release tar files can now also be downloaded from 
  https://yaml.dev/ruamel-dl-tagged-releases/ please adjust if you use 
  https://sourceforge.net/projects/ruamel-dl-tagged-releases/files/ as that 
  repository in sourceforge will no longer be updated from some later date.

[0.18.13, 2025-06-06]:
- Fix line wrapping on plain scalars not observing width correctly. Issue 529, 
  reported by [Sebastien 
  Vermeille](https://sourceforge.net/u/svermeille/profile/)
- Fix sha256 and length in RECORD files. Reported by 
  [Evan](https://sourceforge.net/u/bempelise/profile/)

[0.18.12, 2025-05-30]:
- fix additional issue with extra space in double quoted string. Reported by 
  [Saugat Pachhai](https://sourceforge.net/u/skshetry/profile/)
- fix duplicate key url, now pointing to yaml.dev. Reported by 
  [Hugo](https://sourceforge.net/u/hugovk/profile/)
- fix broken RECORD file, which was a problem for uv, not pip. Reported by 
  [konstin](https://sourceforge.net/u/konstin/profile/)

[0.18.11, 2025-05-19]:
- function `load_yaml_guess_indent` now takes an option `yaml` argument so you 
  can provide an already created/configured `YAML` instance
- Sequence item indicator with both comment/empty line before indicator **and** 
  comment before sequence item, could not move comment and raise 
  `NotImplementedError`. Reported by [Karsten 
  Tessarzik](https://sourceforge.net/u/kars10/profile/).
- missing f for f-string (reported by π, via email)
- fixed issue with extra space in double quoted dump (reported by [Jan 
  Möller](https://sourceforge.net/u/redfiredragon/profile/))

[0.18.10, 2025-01-06]:
- implemented changes to the setup.py for Python 3.14 as suggested by [Miro 
  Hrončok](https://sourceforge.net/u/hroncok/profile/) in merge requests (MR not
  merged as those files are copied in from `develop` config)

[0.18.9, 2025-01-05]:
- fix issue with roundtripping 0 in YAML 1.1 reported by [Peter 
  Law](https://sourceforge.net/u/peterjclaw/profile/)

[0.18.8, 2025-01-02]:
- added warning to README.md that PyPI might block updates due to breaking 
  changes

[0.18.7, 2024-12-30]:
- fixes for README (reported by [Kees 
  Bakker](https://sourceforge.net/u/keesb/profile/))
- fixes preserving anchor on scalar integer `0` (issue reported by (Mor 
  Peled)[https://sourceforge.net/u/morp/profile/] and also in a question by 
  [Ravi](https://stackoverflow.com/users/6550398/ravi) on 
  [Stackoverflow](https://stackoverflow.com/a/79306830/1307905))
- fix for formatting of README suggested by [Michael R. 
  Crusoe](https://sourceforge.net/u/crusoe/profile/)

[0.18.6, 2024-02-07]:
- fixed an issue with dataclass loading when the fields were collections (bug 
  found as a result of a question by 
  [FibroMyAlgebra](https://stackoverflow.com/users/6855070/fibromyalgebra) on 
  [StackOverflow](https://stackoverflow.com/a/77485786/1307905))
- fixed an issue loading dataclasses with `InitVar` fields when `from __future__
  import annotations` was used to delay evaluation of typing.

[0.18.5, 2023-11-03]:
- there is some indication that dependent packages have been pinned to use 
  specific (tested) and just install the latest even in Python versions that 
  have end-of-life

[0.18.4, 2023-11-01]:
- YAML() instance has a `doc_infos` attribute which is a cumulative list of 
  DocInfo instances (one for `load()`, one per document for `load_all()`). 
  DocInfo instances contain version information (requested, directive) and tag 
  directive information
- fix issue that the YAML instance tags attribute was not reset between 
  documents, resulting in mixing of tag directives of multiple documents. Now 
  only provides tag directive information on latest document after loading. This
  means tags for dumping must be set **again** after a document is loaded with 
  the same instance. (because of this tags will be removed in a favour of a 
  different mechanism in the future)
- fix issue with multiple document intermixing YAML 1.2 and YAML 1.1, the 
  VersionedResolver now resets
- fix issue with disappearing comment when next token was Tag (still can't have 
  both a comment before a tag and after a tag, before node)

[0.18.3, 2023-10-29]:
- fix issue with spurious newline on first item after comment + nested block 
  sequence
- additional links in the metadata on PyPI (Reported, with pointers how to fix, 
  by [Sorin](https://sourceforge.net/u/ssbarnea/profile/)).

[0.18.2, 2023-10-24]:
- calling the deprecated functions now raises an `AttributeError` with the, 
  somewhat more informative, orginal warning message. Instead of calling 
  `sys.exit(1)`

[0.18.1, 2023-10-24]:
- calling the deprecated functions now always displays the warning message. 
  (reported by [Trend Lloyd](https://sourceforge.net/u/lathiat2/profile/))

[0.18.0, 2023-10-23]:
- the **functions** `scan`, `parse`, `compose`, `load`, `emit`, `serialize`, 
  `dump` and their variants (`_all`, `safe_`, `round_trip_`, etc) have been 
  deprecated (the same named **methods** on `YAML()` instances are, of course, 
  still there.
- |-
  `YAML(typ='unsafe')` now issues a `PendingDeprecationWarning`. This will become deprecated in the 0.18 series
  (probably before the end of 2023).
  You can use `YAML(typ='full')` to dump unregistered Python classes/functions. 
  For loading you'll have to register your classes/functions
  if you want the old, unsafe, functionality. You can still load any tag, like `!!python/name:posix.system', **safely** 
  with the (default) round-trip parser.
- fix for `bytes-like object is required not 'str' while dumping binary 
  streams`. This was reported, analysed and a fix provided by [Vit 
  Zikmund](https://sourceforge.net/u/tlwhitec/profile/)

[0.17.40, 2023-10-20]:
- flow style sets are now preserved ( `!!set {a, b, c} )`. Any values specified 
  when loading are dropped, including `!!null ""`.
- |-
  potential workaround for issue 484: the long_description_content_type including the variant specification `CommonMark`
  can result in problems on Azure. If you can install from `.tar.gz` using
  `RUAMEL_NO_LONG_DESCRIPTION=1 pip install ruamel.yaml --no-binary :all:` then the long description, and its
  offending type, are nog included (in the METADATA). 
  (Reported by [Coury Ditch](https://sourceforge.net/u/cmditch/profile/))
- links in documentation update (reported by [David 
  Hoese](https://sourceforge.net/u/daveydave400/profile/))
- Added some `__repr__` for internally used classes

[0.17.39, 2023-10-19]:
- update README generation, no code changes

[0.17.36, 2023-10-19]:
- fixed issue 480, dumping of a loaded empty flow-style mapping with comment 
  failed (Reported by [Stéphane 
  Brunner](https://sourceforge.net/u/stbrunner/profile/))
- fixed issue 482, caused by DEFAULT_MAPPING_TAG having changes to being a 
  `Tag()` instance, not a string (reported by 
  [yan12125](https://sourceforge.net/u/yan12125/profile/))
- updated documentation to use mkdocs

[0.17.35, 2023-10-04]:
- support for loading dataclasses with `InitVar` variables (some special coding 
  was necessary to get the, unexecpected, default value in the corresponding 
  instance attribute ( example of usage in [this 
  question](https://stackoverflow.com/q/77228378/1307905))

[0.17.34, 2023-10-03]:
- Python 3.12 also loads C version when using `typ='safe'`
- |-
  initial support for loading invoking
  `__post_init__()` on dataclasses that have that
  method after loading a registered dataclass.
  (Originally
  [asked](https://stackoverflow.com/q/51529458/1307905) on
  Stackoverflow by
  [nyanpasu64](https://stackoverflow.com/users/2683842/nyanpasu64)
  and as
  [ticket](https://sourceforge.net/p/ruamel-yaml/tickets/355/) by
  [Patrick Lehmann](https://sourceforge.net/u/paebbels/profile/))

  ```
  @yaml.register_class
  @dataclass
  class ...
  ```


[0.17.33, 2023-09-28]:
- added `flow_seq_start`, `flow_seq_end`, `flow_seq_separator`, 
  `flow_map_start`, `flow_map_end`, `flow_map_separator` **class** attributes to
  the `Emitter` class so flow style output can more easily be influenced (based 
  on [this answer](https://stackoverflow.com/a/76547814/1307905) on a 
  StackOverflow question by [Huw 
  Walters](https://stackoverflow.com/users/291033/huw-walters)).

[0.17.32, 2023-06-17]:
- fix issue with scanner getting stuck in infinite loop

[0.17.31, 2023-05-31]:
- added tag.setter on `ScalarEvent` and on `Node`, that takes either a `Tag` 
  instance, or a str (reported by [Sorin 
  Sbarnea](https://sourceforge.net/u/ssbarnea/profile/))

[0.17.30, 2023-05-30]:
- fix issue 467, caused by Tag instances not being hashable (reported by 
  [Douglas 
  Raillard](https://bitbucket.org/%7Bcf052d92-a278-4339-9aa8-de41923bb556%7D/))

[0.17.29, 2023-05-30]:
- changed the internals of the tag property from a string to a class which 
  allows for preservation of the original handle and suffix. This should result 
  in better results using documents with %TAG directives, as well as preserving 
  URI escapes in tag suffixes.

[0.17.28, 2023-05-26]:
- |-
  fix for issue 464: documents ending with document end marker
  without final newline fail to load (reported by [Mariusz
  Rusiniak](https://sourceforge.net/u/r2dan/profile/))

[0.17.27, 2023-05-25]:
- fix issue with inline mappings as value for merge keys (reported by Sirish on 
  [StackOverflow](https://stackoverflow.com/q/76331049/1307905))
- fix for 468, error inserting after accessing merge attribute on `CommentedMap`
  (reported by [Bastien gerard](https://sourceforge.net/u/bagerard/))
- fix for issue 461 pop + insert on same `CommentedMap` key throwing error 
  (reported by [John Thorvald Wodder 
  II](https://sourceforge.net/u/jwodder/profile/))

[0.17.26, 2023-05-09]:
- fix for error on edge cage for issue 459

[0.17.25, 2023-05-09]:
- fix for regression while dumping wrapped strings with too many backslashes 
  removed (issue 459, reported by [Lele 
  Gaifax](https://sourceforge.net/u/lele/profile/))

[0.17.24, 2023-05-06]:
- rewrite of `CommentedMap.insert()`. If you have a merge key in the YAML 
  document for the mapping you insert to, the position value should be the one 
  as you look at the YAML input. This fixes issue 453 where other keys of a 
  merged in mapping would show up after an insert (reported by [Alex 
  Miller](https://sourceforge.net/u/millerdevel/profile/)). It also fixes a call
  to `.insert()` resulting into the merge key to move to be the first key if it 
  wasn't already and it is also now possible to insert a key before a merge key 
  (even if the fist key in the mapping).
- fix (in the pure Python implementation including default) for issue 447. 
  (reported by [Jack Cherng](https://sourceforge.net/u/jfcherng/profile/), also 
  brought up by brent on 
  [StackOverflow](https://stackoverflow.com/q/40072485/1307905))

[0.17.23, 2023-05-05]:
- fix 458, error on plain scalars starting with word longer than width. 
  (reported by [Kyle Larose](https://sourceforge.net/u/klarose/profile/))
- fix for `.update()` no longer correctly handling keyword arguments (reported 
  by John Lin on [StackOverflow]( https://stackoverflow.com/q/76089100/1307905))
- |-
  fix issue 454: high Unicode (emojis) in quoted strings always
  escaped (reported by [Michal
  Čihař](https://sourceforge.net/u/nijel/profile/) based on a
  question on StackOverflow).
- fix issue with emitter conservatively inserting extra backslashes in wrapped 
  quoted strings (reported by thebenman on 
  [StackOverflow](https://stackoverflow.com/q/75631454/1307905))

[0.17.22, 2023-05-02]:
- fix issue 449 where the second exclamation marks got URL encoded (reported and
  fixing PR provided by [John Stark](https://sourceforge.net/u/jods/profile/))
- fix issue with indent != 2 and literal scalars with empty first line (reported
  by wrdis on [StackOverflow](https://stackoverflow.com/q/75584262/1307905))
- updated `__repr__` of CommentedMap, now that Python's dict is ordered -> no 
  more `ordereddict(list-of-tuples)`
- merge MR 4, handling OctalInt in YAML 1.1 (provided by [Jacob 
  Floyd](https://sourceforge.net/u/cognifloyd/profile/))
- fix loading of `!!float 42` (reported by Eric on [Stack 
  overflow](https://stackoverflow.com/a/71555107/1307905))
- line numbers are now set on `CommentedKeySeq` and `CommentedKeyMap` (which are
  created if you have a sequence resp. mapping as the key in a mapping)
- |-
  plain scalars: put single words longer than width on a line of
  their own, instead of after the previous line (issue 427, reported
  by [Antoine
  Cotten](https://sourceforge.net/u/antoineco/profile/)). Caveat:
  this currently results in a space ending the previous line.
- |-
  fix for folded scalar part of 421: comments after ">" on first
  line of folded scalars are now preserved (as were those in the
  same position on literal scalars). Issue reported by Jacob Floyd.
- added stacklevel to warnings
- typing changed from Py2 compatible comments to Py3, removed various Py2-isms

[0.17.21, 2022-02-12]:
- fix bug in calling `.compose()` method with `pathlib.Path` instance.

[0.17.20, 2022-01-03]:
- fix error in microseconds while rounding datetime fractions >= 9999995 
  (reported by [Luis Ferreira](https://sourceforge.net/u/ljmf00/))

[0.17.19, 2021-12-26]:
- fix mypy problems (reported by 
  [Arun](https://sourceforge.net/u/arunppsg/profile/))

[0.17.18, 2021-12-24]:
- copy-paste error in folded scalar comment attachment (reported by [Stephan 
  Geulette](https://sourceforge.net/u/sgeulette/profile/))
- fix 411, indent error comment between key empty seq value (reported by 
  [Guillermo Julián](https://sourceforge.net/u/gjulianm/profile/))

[0.17.17, 2021-10-31]:
- extract timestamp matching/creation to util

[0.17.16, 2021-08-28]:
- 398 also handle issue 397 when comment is newline

[0.17.15, 2021-08-28]:
- fix issue 397, insert comment before key when a comment between key and value 
  exists (reported by [Bastien gerard](https://sourceforge.net/u/bagerard/))

[0.17.14, 2021-08-25]:
- fix issue 396, inserting key/val in merged-in dictionary (reported by [Bastien
  gerard](https://sourceforge.net/u/bagerard/))

[0.17.13, 2021-08-21]:
- minor fix in attr handling

[0.17.12, 2021-08-21]:
- fix issue with anchor on registered class not preserved and those classes 
  using package attrs with `@attr.s()` (both reported by 
  [ssph](https://sourceforge.net/u/sph/))

[0.17.11, 2021-08-19]:
- fix error baseclass for `DuplicateKeyError` (reported by [Łukasz 
  Rogalski](https://sourceforge.net/u/lrogalski/))
- fix typo in reader error message, causing `KeyError` during reader error 
  (reported by [MTU](https://sourceforge.net/u/mtu/))

[0.17.10, 2021-06-24]:
- fix issue 388, token with old comment structure != two elements (reported by 
  [Dimitrios Bariamis](https://sourceforge.net/u/dbdbc/))

[0.17.9, 2021-06-10]:
- fix issue with updating CommentedMap (reported by sri on 
  [StackOverflow](https://stackoverflow.com/q/67911659/1307905))

[0.17.8, 2021-06-09]:
- fix for issue 387 where templated anchors on tagged object did get set 
  resulting in potential id reuse. (reported by [Artem 
  Ploujnikov](https://sourceforge.net/u/flexthink/))

[0.17.7, 2021-05-31]:
- issue 385 also affected other deprecated loaders (reported via email by Oren 
  Watson)

[0.17.6, 2021-05-31]:
- merged type annotations update provided by [Jochen 
  Sprickerhof](https://sourceforge.net/u/jspricke/)
- |-
  fix for issue 385: deprecated round_trip_loader function not
  working (reported by [Mike
  Gouline](https://sourceforge.net/u/gouline/))
- wasted a few hours getting rid of mypy warnings/errors

[0.17.5, 2021-05-30]:
- fix for issue 384 `!!set` with aliased entry resulting in broken YAML on rt 
  reported by [William Kimball](https://sourceforge.net/u/william303/))

[0.17.4, 2021-04-07]:
- prevent (empty) comments from throwing assertion error (issue 351 reported by 
  [William Kimball](https://sourceforge.net/u/william303/)) comments (or empty 
  line) will be dropped

[0.17.3, 2021-04-07]:
- fix for issue 382 caused by an error in a format string (reported by [William 
  Kimball](https://sourceforge.net/u/william303/))
- |-
  allow expansion of aliases by setting `yaml.composer.return_alias = lambda s: copy.deepcopy(s)`
  (as per [Stackoverflow answer](https://stackoverflow.com/a/66983530/1307905))

[0.17.2, 2021-03-29]:
- change -py2.py3-none-any.whl to -py3-none-any.whl, and remove 0.17.1

[0.17.1, 2021-03-29]:
- |-
  added 'Programming Language :: Python :: 3 :: Only', and
  removing 0.17.0 from PyPI (reported by [Alasdair
  Nicol](https://sourceforge.net/u/alasdairnicol/))

[0.17.0, 2021-03-26]:
- removed because of incomplete classifiers
- this release no longer supports Python 2.7, most if not all Python 2 specific 
  code is removed. The 0.17.x series is the last to support Python 3.5 (this 
  also allowed for removal of the dependency on `ruamel.std.pathlib`)
- remove Python2 specific code branches and adaptations (u-strings)
- prepare % code for f-strings using `_F`
- allow PyOxidisation ([issue 
  324](https://sourceforge.net/p/ruamel-yaml/tickets/324/) resp. [issue 
  171](https://github.com/indygreg/PyOxidizer/issues/171))
- replaced Python 2 compatible enforcement of keyword arguments with '*'
- the old top level *functions* `load`, `safe_load`, `round_trip_load`, `dump`, 
  `safe_dump`, `round_trip_dump`, `scan`, `parse`, `compose`, `emit`, 
  `serialize` as well as their `_all` variants for multi-document streams, now 
  issue a `PendingDeprecationning` (e.g. when run from pytest, but also Python 
  is started with `-Wd`). Use the methods on `YAML()`, which have been extended.
- |-
  fix for issue 376: indentation changes could put literal/folded
  scalar to start before the `#` column of a following comment.
  Effectively making the comment part of the scalar in the output.
  (reported by [Bence Nagy](https://sourceforge.net/u/underyx/))

[0.16.13, 2021-03-05]:
- |-
  fix for issue 359: could not update() CommentedMap with keyword
  arguments (reported by [Steve
  Franchak](https://sourceforge.net/u/binaryadder/))
- |-
  fix for issue 365: unable to dump mutated TimeStamp objects
  (reported by [Anton Akmerov](https://sourceforge.net/u/akhmerov))
- |-
  fix for issue 371: unable to add comment without starting space
  (reported by [Mark Grandi](https://sourceforge.net/u/mgrandi))
- |-
  fix for issue 373: recursive call to walk_tree not preserving
  all params (reported by [eulores](https://sourceforge.net/u/eulores/))
- a None value in a flow-style sequence is now dumped as `null` instead of 
  `!!null ''` (reported by mcarans on 
  [StackOverflow](https://stackoverflow.com/a/66489600/1307905))

[0.16.12, 2020-09-04]:
- update links in doc

[0.16.11, 2020-09-03]:
- workaround issue with setuptools 0.50 and importing pip (fix by 
  [jaraco](https://github.com/pypa/setuptools/issues/2355#issuecomment-685159580)

[0.16.10, 2020-02-12]:
- (auto) updated image references in README to sourceforge

[0.16.9, 2020-02-11]:
- update CHANGES

[0.16.8, 2020-02-11]:
- update requirements so that ruamel.yaml.clib is installed for 3.8, as it has 
  become available (via manylinux builds)

[0.16.7, 2020-01-30]:
- fix typchecking issue on TaggedScalar (reported by Jens Nielsen)
- fix error in dumping literal scalar in sequence with comments before element 
  (reported by [EJ Etherington](https://sourceforge.net/u/ejether/))

[0.16.6, 2020-01-20]:
- fix empty string mapping key roundtripping with preservation of quotes as `? 
  ''` (reported via email by Tomer Aharoni).
- fix incorrect state setting in class constructor (reported by [Douglas 
  Raillard](https://bitbucket.org/%7Bcf052d92-a278-4339-9aa8-de41923bb556%7D/))
- adjust deprecation warning test for Hashable, as that no longer warns 
  (reported by [Jason 
  Montleon](https://bitbucket.org/%7B8f377d12-8d5b-4069-a662-00a2674fee4e%7D/))

[0.16.5, 2019-08-18]:
- allow for `YAML(typ=['unsafe', 'pytypes'])`

[0.16.4, 2019-08-16]:
- fix output of TAG directives with `#` (reported by [Thomas 
  Smith](https://bitbucket.org/%7Bd4c57a72-f041-4843-8217-b4d48b6ece2f%7D/))

[0.16.3, 2019-08-15]:
- split construct_object
- change stuff back to keep mypy happy
- move setting of version based on YAML directive to scanner, allowing to check 
  for file version during TAG directive scanning

[0.16.2, 2019-08-15]:
- preserve YAML and TAG directives on roundtrip, correctly output `#` in URL for
  YAML 1.2 (both reported by [Thomas 
  Smith](https://bitbucket.org/%7Bd4c57a72-f041-4843-8217-b4d48b6ece2f%7D/))

[0.16.1, 2019-08-08]:
- Force the use of new version of ruamel.yaml.clib (reported by [Alex 
  Joz](https://bitbucket.org/%7B9af55900-2534-4212-976c-61339b6ffe14%7D/))
- Allow `#` in tag URI as these are allowed in YAML 1.2 (reported by [Thomas 
  Smith](https://bitbucket.org/%7Bd4c57a72-f041-4843-8217-b4d48b6ece2f%7D/))

[0.16.0, 2019-07-25]:
- split of C source that generates `.so` file to [ruamel.yaml.clib]( 
  https://pypi.org/project/ruamel.yaml.clib/)
- duplicate keys are now an error when working with the old API as well

[0.15.100, 2019-07-17]:
- fixing issue with dumping deep-copied data from commented YAML, by providing 
  both the memo parameter to __deepcopy__, and by allowing startmarks to be 
  compared on their content (reported by `Theofilos Petsios 
  <https://bitbucket.org/%7Be550bc5d-403d-4fda-820b-bebbe71796d3%7D/>`__)

[0.15.99, 2019-07-12]:
- add `py.typed` to distribution, based on a PR submitted by `Michael Crusoe 
  <https://bitbucket.org/%7Bc9fbde69-e746-48f5-900d-34992b7860c8%7D/>`__
- merge PR 40 (also by Michael Crusoe) to more accurately specify repository in 
  the README (also reported in a misunderstood issue some time ago)

[0.15.98, 2019-07-09]:
- regenerate ext/_ruamel_yaml.c with Cython version 0.29.12, needed for Python 
  3.8.0b2 (reported by `John Vandenberg 
  <https://bitbucket.org/%7B6d4e8487-3c97-4dab-a060-088ec50c682c%7D/>`__)

[0.15.97, 2019-06-06]:
- regenerate ext/_ruamel_yaml.c with Cython version 0.29.10, needed for Python 
  3.8.0b1
- regenerate ext/_ruamel_yaml.c with Cython version 0.29.9, needed for Python 
  3.8.0a4 (reported by `Anthony Sottile 
  <https://bitbucket.org/%7B569cc8ea-0d9e-41cb-94a4-19ea517324df%7D/>`__)

[0.15.96, 2019-05-16]:
- fix failure to indent comments on round-trip anchored block style scalars in 
  block sequence (reported by `William Kimball 
  <https://bitbucket.org/%7Bba35ed20-4bb0-46f8-bb5d-c29871e86a22%7D/>`__)

[0.15.95, 2019-05-16]:
- fix failure to round-trip anchored scalars in block sequence (reported by 
  `William Kimball 
  <https://bitbucket.org/%7Bba35ed20-4bb0-46f8-bb5d-c29871e86a22%7D/>`__)
- wheel files for Python 3.4 no longer provided (`Python 3.4 EOL 2019-03-18 
  <https://www.python.org/dev/peps/pep-0429/>`__)

[0.15.94, 2019-04-23]:
- fix missing line-break after end-of-file comments not ending in line-break 
  (reported by `Philip Thompson 
  <https://bitbucket.org/%7Be42ba205-0876-4151-bcbe-ccaea5bd13ce%7D/>`__)

[0.15.93, 2019-04-21]:
- fix failure to parse empty implicit flow mapping key
- in YAML 1.1 plains scalars `y`, 'n', `Y`, and 'N' are now correctly recognised
  as booleans and such strings dumped quoted (reported by `Marcel Bollmann 
  <https://bitbucket.org/%7Bd8850921-9145-4ad0-ac30-64c3bd9b036d%7D/>`__)

[0.15.92, 2019-04-16]:
- fix failure to parse empty implicit block mapping key (reported by `Nolan W 
  <https://bitbucket.org/i2labs/>`__)

[0.15.91, 2019-04-05]:
- allowing duplicate keys would not work for merge keys (reported by mamacdon on
  `StackOverflow <https://stackoverflow.com/questions/55540686/>`__

[0.15.90, 2019-04-04]:
- fix issue with updating `CommentedMap` from list of tuples (reported by `Peter
  Henry <https://bitbucket.org/mosbasik/>`__)

[0.15.89, 2019-02-27]:
- fix for items with flow-mapping in block sequence output on single line 
  (reported by `Zahari Dim <https://bitbucket.org/zahari_dim/>`__)
- fix for safe dumping erroring in creation of representereror when dumping 
  namedtuple (reported and solution by `Jaakko Kantojärvi 
  <https://bitbucket.org/raphendyr/>`__)

[0.15.88, 2019-02-12]:
- fix inclusing of python code from the subpackage data (containing extra tests,
  reported by `Florian Apolloner <https://bitbucket.org/apollo13/>`__)

[0.15.87, 2019-01-22]:
- fix problem with empty lists and the code to reinsert merge keys (reported via
  email by Zaloo)

[0.15.86, 2019-01-16]:
- reinsert merge key in its old position (reported by grumbler on <Stackoverflow
  <https://stackoverflow.com/a/54206512/1307905>`__)
- fix for issue with non-ASCII anchor names (reported and fix provided by 
  Dandaleon Flux via email)
- fix for issue when parsing flow mapping value starting with colon (in pure 
  Python only) (reported by `FichteFoll <https://bitbucket.org/FichteFoll/>`__)

[0.15.85, 2019-01-08]:
- the types used by `SafeConstructor` for mappings and sequences can now by set 
  by assigning to `XXXConstructor.yaml_base_dict_type` (and `..._list_type`), 
  preventing the need to copy two methods with 50+ lines that had `var = {}` 
  hardcoded.  (Implemented to help solve an feature request by `Anthony Sottile 
  <https://bitbucket.org/asottile/>`__ in an easier way)

[0.15.84, 2019-01-07]:
- fix for `CommentedMap.copy()` not returning `CommentedMap`, let alone copying 
  comments etc. (reported by `Anthony Sottile 
  <https://bitbucket.org/asottile/>`__)

[0.15.83, 2019-01-02]:
- fix for bug in roundtripping aliases used as key (reported via email by Zaloo)

[0.15.82, 2018-12-28]:
- anchors and aliases on scalar int, float, string and bool are now preserved. 
  Anchors do not need a referring alias for these (reported by `Alex Harvey 
  <https://bitbucket.org/alexharv074/>`__)
- anchors no longer lost on tagged objects when roundtripping (reported by 
  `Zaloo <https://bitbucket.org/zaloo/>`__)

[0.15.81, 2018-12-06]:
- fix issue saving methods of metaclass derived classes (reported and fix 
  provided by `Douglas Raillard <https://bitbucket.org/DouglasRaillard/>`__)

[0.15.80, 2018-11-26]:
- fix issue emitting BEL character when round-tripping invalid folded input 
  (reported by Isaac on `StackOverflow 
  <https://stackoverflow.com/a/53471217/1307905>`__)

[0.15.79, 2018-11-21]:
- fix issue with anchors nested deeper than alias (reported by gaFF on 
  `StackOverflow <https://stackoverflow.com/a/53397781/1307905>`__)

[0.15.78, 2018-11-15]:
- fix setup issue for 3.8 (reported by `Sidney Kuyateh 
  <https://bitbucket.org/autinerd/>`__)

[0.15.77, 2018-11-09]:
- setting `yaml.sort_base_mapping_type_on_output = False`, will prevent explicit
  sorting by keys in the base representer of mappings. Roundtrip already did not
  do this. Usage only makes real sense for Python 3.6+ (feature request by 
  `Sebastian Gerber <https://bitbucket.org/spacemanspiff2007/>`__).
- implement Python version check in YAML metadata in `_test/test_z_data.py`

[0.15.76, 2018-11-01]:
- fix issue with empty mapping and sequence loaded as flow-style (mapping 
  reported by `Min RK <https://bitbucket.org/minrk/>`__, sequence by `Maged 
  Ahmed <https://bitbucket.org/maged2/>`__)

[0.15.75, 2018-10-27]:
- fix issue with single '?' scalar (reported by `Terrance 
  <https://bitbucket.org/OllieTerrance/>`__)
- fix issue with duplicate merge keys (prompted by `answering 
  <https://stackoverflow.com/a/52852106/1307905>`__ a `StackOverflow question 
  <https://stackoverflow.com/q/52851168/1307905>`__ by `math 
  <https://stackoverflow.com/users/1355634/math>`__)

[0.15.74, 2018-10-17]:
- fix dropping of comment on rt before sequence item that is sequence item 
  (reported by `Thorsten Kampe <https://bitbucket.org/thorstenkampe/>`__)

[0.15.73, 2018-10-16]:
- fix irregular output on pre-comment in sequence within sequence (reported by 
  `Thorsten Kampe <https://bitbucket.org/thorstenkampe/>`__)
- allow non-compact (i.e. next line) dumping sequence/mapping within sequence.

[0.15.72, 2018-10-06]:
- fix regression on explicit 1.1 loading with the C based scanner/parser 
  (reported by `Tomas Vavra <https://bitbucket.org/xtomik/>`__)

[0.15.71, 2018-09-26]:
- fix regression where handcrafted CommentedMaps could not be initiated 
  (reported by `Dan Helfman <https://bitbucket.org/dhelfman/>`__)
- fix regression with non-root literal scalars that needed indent indicator 
  (reported by `Clark Breyman <https://bitbucket.org/clarkbreyman/>`__)
- tag:yaml.org,2002:python/object/apply now also uses __qualname__ on PY3 
  (reported by `Douglas RAILLARD <https://bitbucket.org/DouglasRaillard/>`__)

[0.15.70, 2018-09-21]:
- reverted CommentedMap and CommentedSeq to subclass ordereddict resp. list, 
  reimplemented merge maps so that both `dict(**commented_map_instance)` and 
  JSON dumping works. This also allows checking with `isinstance()` on `dict` 
  resp. `list`. (Proposed by `Stuart Berg 
  <https://bitbucket.org/stuarteberg/>`__, with feedback from `blhsing 
  <https://stackoverflow.com/users/6890912/blhsing>`__ on `StackOverflow 
  <https://stackoverflow.com/q/52314186/1307905>`__)

[0.15.69, 2018-09-20]:
- fix issue with dump_all gobbling end-of-document comments on parsing (reported
  by `Pierre B. <https://bitbucket.org/octplane/>`__)

[0.15.68, 2018-09-20]:
- fix issue with parsabel, but incorrect output with nested flow-style sequences
  (reported by `Dougal Seeley <https://bitbucket.org/dseeley/>`__)
- fix issue with loading Python objects that have __setstate__ and recursion in 
  parameters (reported by `Douglas RAILLARD 
  <https://bitbucket.org/DouglasRaillard/>`__)

[0.15.67, 2018-09-19]:
- fix issue with extra space inserted with non-root literal strings (Issue 
  reported and PR with fix provided by `Naomi Seyfer 
  <https://bitbucket.org/sixolet/>`__.)

[0.15.66, 2018-09-07]:
- fix issue with fold indicating characters inserted in safe_load-ed folded 
  strings (reported by `Maximilian Hils <https://bitbucket.org/mhils/>`__).

[0.15.65, 2018-09-07]:
- |-
  fix issue #232 revert to throw ParserError for unexcpected `]`
  and `}` instead of IndexError. (Issue reported and PR with fix
  provided by `Naomi Seyfer <https://bitbucket.org/sixolet/>`__.)
- added `key` and `reverse` parameter (suggested by Jannik Klemm via email)
- indent root level literal scalars that have directive or document end markers 
  at the beginning of a line

[0.15.64, 2018-08-30]:
- |-
  support round-trip of tagged sequences: `!Arg [a, {b: 1}]`
- |-
  single entry mappings in flow sequences now written by default without quotes
  set `yaml.brace_single_entry_mapping_in_flow_sequence=True` to force
  getting `[a, {b: 1}, {c: {d: 2}}]` instead of the default `[a, b: 1, c: {d: 2}]`
- fix issue when roundtripping floats starting with a dot such as `.5` (reported
  by `Harrison Gregg <https://bitbucket.org/HarrisonGregg/>`__)

[0.15.63, 2018-08-29]:
- small fix only necessary for Windows users that don't use wheels.

[0.15.62, 2018-08-29]:
- C based reader/scanner & emitter now allow setting of 1.2 as YAML version. ** 
  The loading/dumping is still YAML 1.1 code**, so use the common subset of YAML
  1.2 and 1.1 (reported by `Ge Yang <https://bitbucket.org/yangge/>`__)

[0.15.61, 2018-08-23]:
- support for round-tripping folded style scalars (initially requested by 
  `Johnathan Viduchinsky <https://bitbucket.org/johnathanvidu/>`__)
- update of C code
- speed up of scanning (~30% depending on the input)

[0.15.60, 2018-08-18]:
- cleanup for mypy
- spurious print in library (reported by `Lele Gaifax 
  <https://bitbucket.org/lele/>`__), now automatically checked

[0.15.59, 2018-08-17]:
- issue with C based loader and leading zeros (reported by `Tom Hamilton Stubber
  <https://bitbucket.org/TomHamiltonStubber/>`__)

[0.15.58, 2018-08-17]:
- |-
  simple mappings can now be used as keys when round-tripping::

    {a: 1, b: 2}: hello world
      
  although using the obvious operations (del, popitem) on the key will
  fail, you can mutilate it by going through its attributes. If you load the
  above YAML in `d`, then changing the value is cumbersome:

      d = {CommentedKeyMap([('a', 1), ('b', 2)]): "goodbye"}

  and changing the key even more so:

      d[CommentedKeyMap([('b', 1), ('a', 2)])] = d.pop(
                   CommentedKeyMap([('a', 1), ('b', 2)]))

  (you can use a `dict` instead of a list of tuples (or ordereddict), but that might result
  in a different order, of the keys of the key, in the output)
- check integers to dump with 1.2 patterns instead of 1.1 (reported by `Lele 
  Gaifax <https://bitbucket.org/lele/>`__)


[0.15.57, 2018-08-15]:
- Fix that CommentedSeq could no longer be used in adding or do a copy (reported
  by `Christopher Wright <https://bitbucket.org/CJ-Wright4242/>`__)

[0.15.56, 2018-08-15]:
- fix issue with `python -O` optimizing away code (reported, and detailed cause 
  pinpointed, by `Alex Grönholm <https://bitbucket.org/agronholm/>`__

[0.15.55, 2018-08-14]:

- unmade `CommentedSeq` a subclass of `list`. It is now indirectly a subclass of
  the standard `collections.abc.MutableSequence` (without .abc if you are still 
  on Python2.7). If you do `isinstance(yaml.load('[1, 2]'), list)`) anywhere in 
  your code replace `list` with `MutableSequence`.  Directly, `CommentedSeq` is 
  a subclass of the abstract baseclass 
  `ruamel.yaml.compat.MutableScliceableSequence`, with the result that 
  *(extended) slicing is supported on `CommentedSeq`*. (reported by `Stuart Berg
  <https://bitbucket.org/stuarteberg/>`__)
- duplicate keys (or their values) with non-ascii now correctly report in 
  Python2, instead of raising a Unicode error. (Reported by `Jonathan Pyle 
  <https://bitbucket.org/jonathan_pyle/>`__)

[0.15.54, 2018-08-13]:

- fix issue where a comment could pop-up twice in the output (reported by `Mike 
  Kazantsev <https://bitbucket.org/mk_fg/>`__ and by `Nate Peterson 
  <https://bitbucket.org/ndpete21/>`__)
- fix issue where JSON object (mapping) without spaces was not parsed properly 
  (reported by `Marc Schmidt <https://bitbucket.org/marcj/>`__)
- fix issue where comments after empty flow-style mappings were not emitted 
  (reported by `Qinfench Chen <https://bitbucket.org/flyin5ish/>`__)

[0.15.53, 2018-08-12]:
- fix issue with flow style mapping with comments gobbled newline (reported by 
  `Christopher Lambert <https://bitbucket.org/XN137/>`__)
- fix issue where single '+' under YAML 1.2 was interpreted as integer, erroring
  out (reported by `Jethro Yu <https://bitbucket.org/jcppkkk/>`__)

[0.15.52, 2018-08-09]:
- added `.copy()` mapping representation for round-tripping (`CommentedMap`) to 
  fix incomplete copies of merged mappings (reported by `Will Richards 
  <https://bitbucket.org/will_richards/>`__)
- Also unmade that class a subclass of ordereddict to solve incorrect behaviour 
  for `{**merged-mapping}` and `dict(**merged-mapping)` (reported by `Filip 
  Matzner <https://bitbucket.org/FloopCZ/>`__)

[0.15.51, 2018-08-08]:
- Fix method name dumps (were not dotted) and loads (reported by `Douglas 
  Raillard <https://bitbucket.org/DouglasRaillard/>`__)
- Fix spurious trailing white-space caused when the comment start column was no 
  longer reached and there was no actual EOL comment (e.g. following empty line)
  and doing substitutions, or when quotes around scalars got dropped.  (reported
  by `Thomas Guillet <https://bitbucket.org/guillett/>`__)

[0.15.50, 2018-08-05]:
- Allow `YAML()` as a context manager for output, thereby making it much easier 
  to generate multi-documents in a stream.
- Fix issue with incorrect type information for `load()` and `dump()` (reported 
  by `Jimbo Jim <https://bitbucket.org/jimbo1qaz/>`__)

[0.15.49, 2018-08-05]:
- |-
  fix preservation of leading newlines in root level literal style scalar,
    and preserve comment after literal style indicator (`|  # some comment`)
    Both needed for round-tripping multi-doc streams in 
    `ryd <https://pypi.org/project/ryd/>`__.

[0.15.48, 2018-08-03]:
- |-
  housekeeping: `oitnb` for formatting, mypy 0.620 upgrade and conformity

[0.15.47, 2018-07-31]:
- fix broken 3.6 manylinux1 (result of an unclean `build` (reported by `Roman 
  Sichnyi <https://bitbucket.org/rsichnyi-gl/>`__)


[0.15.46, 2018-07-29]:
- fixed DeprecationWarning for importing from `collections` on 3.7 (issue 210, 
  reported by `Reinoud Elhorst <https://bitbucket.org/reinhrst/>`__). It was 
  `difficult to find why tox/pytest did not report 
  <https://stackoverflow.com/q/51573204/1307905>`__ and as time consuming to 
  actually `fix <https://stackoverflow.com/a/51573205/1307905>`__ the tests.

[0.15.45, 2018-07-26]:
- After adding failing test for `YAML.load_all(Path())`, remove StopIteration 
  (PR provided by `Zachary Buhman <https://bitbucket.org/buhman/>`__, also 
  reported by `Steven Hiscocks <https://bitbucket.org/sdhiscocks/>`__.

[0.15.44, 2018-07-14]:
- Correct loading plain scalars consisting of numerals only and starting with 
  `0`, when not explicitly specifying YAML version 1.1. This also fixes the 
  issue about dumping string `'019'` as plain scalars as reported by `Min RK 
  <https://bitbucket.org/minrk/>`__, that prompted this chance.

[0.15.43, 2018-07-12]:
- |-
  merge PR33: Python2.7 on Windows is narrow, but has no
    `sysconfig.get_config_var('Py_UNICODE_SIZE')`. (merge provided by
    `Marcel Bargull <https://bitbucket.org/mbargull/>`__)
  - `register_class()` now returns class (proposed by
    `Mike Nerone <https://bitbucket.org/Manganeez/>`__}

[0.15.42, 2018-07-01]:
- fix regression showing only on narrow Python 2.7 (py27mu) builds (with help 
  from `Marcel Bargull <https://bitbucket.org/mbargull/>`__ and `Colm O'Connor 
  <>`__).
- run pre-commit `tox` on Python 2.7 wide and narrow, as well as 
  3.4/3.5/3.6/3.7/pypy

[0.15.41, 2018-06-27]:
- add detection of C-compile failure (investigation prompted by `StackOverlow 
  <https://stackoverflow.com/a/51057399/1307905>`__ by `Emmanuel Blot 
  <https://stackoverflow.com/users/8233409/emmanuel-blot>`__), which was removed
  while no longer dependent on `libyaml`, C-extensions compilation still needs a
  compiler though.

[0.15.40, 2018-06-18]:
- added links to landing places as suggested in issue 190 by `KostisA 
  <https://bitbucket.org/ankostis/>`__
- |-
  fixes issue #201: decoding unicode escaped tags on Python2, reported
  by `Dan Abolafia <https://bitbucket.org/danabo/>`__

[0.15.39, 2018-06-16]:
- merge PR27 improving package startup time (and loading when regexp not 
  actually used), provided by `Marcel Bargull 
  <https://bitbucket.org/mbargull/>`__

[0.15.38, 2018-06-13]:
- fix for losing precision when roundtripping floats by `Rolf Wojtech 
  <https://bitbucket.org/asomov/>`__
- fix for hardcoded dir separator not working for Windows by `Nuno André 
  <https://bitbucket.org/nu_no/>`__
- typo fix by `Andrey Somov <https://bitbucket.org/asomov/>`__

[0.15.37, 2018-03-21]:
- again trying to create installable files for 187

[0.15.36, 2018-02-07]:
- fix issue 187, incompatibility of C extension with 3.7 (reported by Daniel 
  Blanchard)

[0.15.35, 2017-12-03]:
- allow `None` as stream when specifying `transform` parameters to 
  `YAML.dump()`. This is useful if the transforming function doesn't return a 
  meaningful value (inspired by `StackOverflow 
  <https://stackoverflow.com/q/47614862/1307905>`__ by `rsaw 
  <https://stackoverflow.com/users/406281/rsaw>`__).

[0.15.34, 2017-09-17]:
- fix for issue 157: CDumper not dumping floats (reported by Jan Smitka)

[0.15.33, 2017-08-31]:
- support for "undefined" round-tripping tagged scalar objects (in addition to 
  tagged mapping object). Inspired by a use case presented by Matthew Patton on 
  `StackOverflow <https://stackoverflow.com/a/45967047/1307905>`__.
- |-
  fix issue 148: replace cryptic error message when using `!!timestamp` with an
  incorrectly formatted or non-scalar. Reported by FichteFoll.

[0.15.32, 2017-08-21]:
- |-
  allow setting `yaml.default_flow_style = None` (default: `False`) for for `typ='rt'`.
- fix for issue 149: multiplications on `ScalarFloat` now return `float`

[0.15.31, 2017-08-15]:
- fix Comment dumping

[0.15.30, 2017-08-14]:
- |-
  fix for issue with "compact JSON" not parsing: `{"in":{},"out":{}}`
  (reported on `StackOverflow <https://stackoverflow.com/q/45681626/1307905>`_ by
  `mjalkio <https://stackoverflow.com/users/5130525/mjalkio>`_

[0.15.29, 2017-08-14]:
- |-
  fix issue #51: different indents for mappings and sequences (reported by Alex Harvey)
- fix for flow sequence/mapping as element/value of block sequence with 
  sequence-indent minus dash-offset not equal two.

[0.15.28, 2017-08-13]:
- |-
  fix issue #61: merge of merge cannot be __repr__-ed (reported by Tal Liron)

[0.15.27, 2017-08-13]:
- fix issue 62, YAML 1.2 allows `?` and `:` in plain scalars if non-ambigious 
  (reported by nowox)
- fix lists within lists which would make comments disappear

[0.15.26, 2017-08-10]:
- fix for disappearing comment after empty flow sequence (reported by 
  oit-tzhimmash)

[0.15.25, 2017-08-09]:
- fix for problem with dumping (unloaded) floats (reported by eyenseo)

[0.15.24, 2017-08-09]:
- added ScalarFloat which supports roundtripping of 23.1, 23.100, 42.00E+56, 
  0.0, -0.0 etc. while keeping the format. Underscores in mantissas are not 
  preserved/supported (yet, is anybody using that?).
- (finally) fixed longstanding issue 23 (reported by `Antony Sottile 
  <https://bitbucket.org/asottile/>`_), now handling comment between block 
  mapping key and value correctly
- warn on YAML 1.1 float input that is incorrect (triggered by invalid YAML 
  provided by Cecil Curry)
- |-
  allow setting of boolean representation (`false`, `true`) by using:
  `yaml.boolean_representation = [u'False', u'True']`

[0.15.23, 2017-08-01]:
- fix for round_tripping integers on 2.7.X > sys.maxint (reported by ccatterina)

[0.15.22, 2017-07-28]:
- fix for round_tripping singe excl. mark tags doubling (reported and fix by Jan
  Brezina)

[0.15.21, 2017-07-25]:
- fix for writing unicode in new API, 
  https://stackoverflow.com/a/45281922/1307905

[0.15.20, 2017-07-23]:
- wheels for windows including C extensions

[0.15.19, 2017-07-13]:
- added object constructor for rt, decorator `yaml_object` to replace 
  YAMLObject.
- fix for problem using load_all with Path() instance
- fix for load_all in combination with zero indent block style literal 
  (`pure=True` only!)

[0.15.18, 2017-07-04]:
- missing `pure` attribute on `YAML` useful for implementing `!include` tag 
  constructor for `including YAML files in a YAML file 
  <https://stackoverflow.com/a/44913652/1307905>`_
- some documentation improvements
- trigger of doc build on new revision

[0.15.17, 2017-07-03]:
- support for Unicode supplementary Plane **output** with allow_unicode (input 
  was already supported, triggered by `this 
  <https://stackoverflow.com/a/44875714/1307905>`_ Stack Overflow Q&A)

[0.15.16, 2017-07-01]:
- minor typing issues (reported and fix provided by `Manvendra Singh 
  <https://bitbucket.org/manu-chroma/>`_)
- small doc improvements

[0.15.15, 2017-06-27]:
- fix for issue 135, typ='safe' not dumping in Python 2.7 (reported by Andrzej 
  Ostrowski <https://bitbucket.org/aostr123/>`_)

[0.15.14, 2017-06-25]:
- setup.py: change ModuleNotFoundError to ImportError (reported and fix by Asley
    Drake)

[0.15.13, 2017-06-24]:
- suppress duplicate key warning on mappings with merge keys (reported by 
  Cameron Sweeney)

[0.15.12, 2017-06-24]:
- remove fatal dependency of setup.py on wheel package (reported by Cameron 
  Sweeney)

[0.15.11, 2017-06-24]:
- fix for issue 130, regression in nested merge keys (reported by `David Fee 
  <https://bitbucket.org/dfee/>`_)

[0.15.10, 2017-06-23]:
- top level PreservedScalarString not indented if not explicitly asked to
- remove Makefile (not very useful anyway)
- some mypy additions

[0.15.9, 2017-06-16]:
- |-
  fix for issue 127: tagged scalars were always quoted and seperated
  by a newline when in a block sequence (reported and largely fixed by
  `Tommy Wang <https://bitbucket.org/twang817/>`_)

[0.15.8, 2017-06-15]:
- allow plug-in install via `install ruamel.yaml[jinja2]`

[0.15.7, 2017-06-14]:
- add plug-in mechanism for load/dump pre resp. post-processing

[0.15.6, 2017-06-10]:
- a set() with duplicate elements now throws error in rt loading
- support for toplevel column zero literal/folded scalar in explicit documents

[0.15.5, 2017-06-08]:
- repeat `load()` on a single `YAML()` instance would fail.

[0.15.4, 2017-06-08]:
- |-
  `transform` parameter on dump that expects a function taking a
  string and returning a string. This allows transformation of the output
  before it is written to stream.
- some updates to the docs

[0.15.3, 2017-06-07]:
- No longer try to compile C extensions on Windows. Compilation can be forced by
  setting the environment variable `RUAMEL_FORCE_EXT_BUILD` to some value before
  starting the `pip install`.

[0.15.2, 2017-06-07]:
- update to conform to mypy 0.511:mypy --strict

[0.15.1, 2017-06-07]:
- Any `duplicate keys 
  <http://yaml.readthedocs.io/en/latest/api.html#duplicate-keys>`_ in mappings 
  generate an error (in the old API this change generates a warning until 0.16)
- dependecy on ruamel.ordereddict for 2.7 now via extras_require

[0.15.0, 2017-06-04]:
- it is now allowed to pass in a `pathlib.Path` as "stream" parameter to all 
  load/dump functions
- passing in a non-supported object (e.g. a string) as "stream" will result in a
  much more meaningful YAMLStreamError.
- assigning a normal string value to an existing CommentedMap key or 
  CommentedSeq element will result in a value cast to the previous value's type 
  if possible.

[0.14.12, 2017-05-14]:
- fix for issue 119, deepcopy not returning subclasses (reported and PR by 
  Constantine Evans <cevans@evanslabs.org>)

[0.14.11, 2017-05-01]:
- fix for issue 103 allowing implicit documents after document end marker line 
  (`...`) in YAML 1.2

[0.14.10, 2017-04-26]:
- fix problem with emitting using cyaml

[0.14.9, 2017-04-22]:
- remove dependency on `typing` while still supporting `mypy` 
  (http://stackoverflow.com/a/43516781/1307905)
- fix unclarity in doc that stated 2.6 is supported (reported by feetdust)

[0.14.8, 2017-04-19]:
- fix Text not available on 3.5.0 and 3.5.1, now proactively setting version 
  guards on all files (reported by `João Paulo Magalhães 
  <https://bitbucket.org/jpmag/>`_)

[0.14.7, 2017-04-18]:
- round trip of integers (decimal, octal, hex, binary) now preserve leading 
  zero(s) padding and underscores. Underscores are presumed to be at regular 
  distances (i.e. `0o12_345_67` dumps back as `0o1_23_45_67` as the space from 
  the last digit to the underscore before that is the determining factor).

[0.14.6, 2017-04-14]:
- binary, octal and hex integers are now preserved by default. This was a known 
  deficiency. Working on this was prompted by the issue report (112) from 
  devnoname120, as well as the additional experience with `.replace()` on 
  `scalarstring` classes.
- fix issues 114 cannot install on Buildozer (reported by mixmastamyk). Setting 
  env. var `RUAMEL_NO_PIP_INSTALL_CHECK` will suppress `pip`-check.

[0.14.5, 2017-04-04]:
- fix issue 109 None not dumping correctly at top level (reported by Andrea 
  Censi)
- fix issue 110 .replace on Preserved/DoubleQuoted/SingleQuoted ScalarString 
  would give back "normal" string (reported by sandres23)

[0.14.4, 2017-03-31]:
- fix readme

[0.14.3, 2017-03-31]:
- fix for 0o52 not being a string in YAML 1.1 (reported on `StackOverflow Q&A 
  43138503><http://stackoverflow.com/a/43138503/1307905>`_ by `Frank D 
  <http://stackoverflow.com/users/7796630/frank-d>`_

[0.14.2, 2017-03-23]:
- fix for old default pip on Ubuntu 14.04 (reported by Sébastien 
  Maccagnoni-Munch)

[0.14.1, 2017-03-22]:
- fix Text not available on 3.5.0 and 3.5.1 (reported by Charles 
  Bouchard-Légaré)

[0.14.0, 2017-03-21]:
- updates for mypy --strict
- preparation for moving away from inheritance in Loader and Dumper, calls from 
  e.g. the Representer to the Serializer.serialize() are now done via the 
  attribute .serializer.serialize(). Usage of .serialize() outside of Serializer
  will be deprecated soon
- some extra tests on main.py functions

[0.13.14, 2017-02-12]:
- fix for issue 97, clipped block scalar followed by empty lines and comment 
  would result in two CommentTokens of which the first was dropped. (reported by
  Colm O'Connor)

[0.13.13, 2017-01-28]:
- fix for issue 96, prevent insertion of extra empty line if indented mapping 
  entries are separated by an empty line (reported by Derrick Sawyer)

[0.13.11, 2017-01-23]:
- allow ':' in flow style scalars if not followed by space. Also don't quote 
  such scalar as this is no longer necessary.
- add python 3.6 manylinux wheel to PyPI

[0.13.10, 2017-01-22]:
- fix for issue 93, insert spurious blank line before single line comment 
  between indented sequence elements (reported by Alex)

[0.13.9, 2017-01-18]:
- fix for issue 92, wrong import name reported by the-corinthian

[0.13.8, 2017-01-18]:
- fix for issue 91, when a compiler is unavailable reported by Maximilian Hils
- fix for deepcopy issue with TimeStamps not preserving 'T', reported on 
  `StackOverflow Q&A <http://stackoverflow.com/a/41577841/1307905>`_ by 
  `Quuxplusone <http://stackoverflow.com/users/1424877/quuxplusone>`_

[0.13.7, 2016-12-27]:
- fix for issue 85, constructor.py importing unicode_literals caused mypy to 
  fail on 2.7 (reported by Peter Amstutz)

[0.13.6, 2016-12-27]:
- fix for issue 83, collections.OrderedDict not representable by SafeRepresenter
  (reported by Frazer McLean)

[0.13.5, 2016-12-25]:
- fix for issue 84, deepcopy not properly working (reported by Peter Amstutz)

[0.13.4, 2016-12-05]:
- another fix for issue 82, change to non-global resolver data broke implicit 
  type specification

[0.13.3, 2016-12-05]:
- fix for issue 82, deepcopy not working (reported by code monk)

[0.13.2, 2016-11-28]:
- fix for comments after empty (null) values  (reported by dsw2127 and cokelaer)

[0.13.1, 2016-11-22]:
- optimisations on memory usage when loading YAML from large files (py3 -50%, 
  py2 -85%)

[0.13.0, 2016-11-20]:
- if `load()` or `load_all()` is called with only a single argument (stream or 
  string) a UnsafeLoaderWarning will be issued once. If appropriate you can 
  surpress this warning by filtering it. Explicitly supplying the 
  `Loader=ruamel.yaml.Loader` argument, will also prevent it from being issued. 
  You should however consider using `safe_load()`, `safe_load_all()` if your 
  YAML input does not use tags.
- allow adding comments before and after keys (based on `StackOveflow Q&A 
  <http://stackoverflow.com/a/40705671/1307905>`_  by `msinn 
  <http://stackoverflow.com/users/7185467/msinn>`_)

[0.12.18, 2016-11-16]:
- another fix for numpy (re-reported independently by PaulG & Nathanial Burdic)

[0.12.17, 2016-11-15]:
- only the RoundTripLoader included the Resolver that supports YAML 1.2 now all 
  loaders do (reported by mixmastamyk)

[0.12.16, 2016-11-13]:
- allow dot char (and many others) in anchor name Fix issue 72 (reported by 
  Shalon Wood)
- |-
  Slightly smarter behaviour dumping strings when no style is
  specified. Single string scalars that start with single quotes
  or have newlines now are dumped double quoted "'abc\nklm'" instead of

    '''abc

      klm'''

[0.12.14, 2016-09-21]:
- preserve round-trip sequences that are mapping keys (prompted by stackoverflow
  question 39595807 from Nowox)

[0.12.13, 2016-09-15]:
- |-
  Fix for issue #60 representation of CommentedMap with merge
  keys incorrect (reported by Tal Liron)

[0.12.11, 2016-09-06]:
- Fix issue 58 endless loop in scanning tokens (reported by Christopher Lambert)

[0.12.10, 2016-09-05]:
- Make previous fix depend on unicode char width (32 bit unicode support is a 
  problem on MacOS reported by David Tagatac)

[0.12.8, 2016-09-05]:
- To be ignored Unicode characters were not properly regex matched (no specific 
  tests, PR by Haraguroicha Hsu)

[0.12.7, 2016-09-03]:
- fixing issue 54 empty lines with spaces (reported by Alex Harvey)

[0.12.6, 2016-09-03]:
- fixing issue 46 empty lines between top-level keys were gobbled (but not 
  between sequence elements, nor between keys in netsted mappings (reported by 
  Alex Harvey)

[0.12.5, 2016-08-20]:
- |-
  fixing issue 45 preserving datetime formatting (submitted by altuin)
  Several formatting parameters are preserved with some normalisation:
- preserve 'T', 't' is replaced by 'T', multiple spaces between date and time 
  reduced to one.
- optional space before timezone is removed
- still using microseconds, but now rounded (.1234567 -> .123457)
- Z/-5/+01:00 preserved

[0.12.4, 2016-08-19]:
- |-
  Fix for issue 44: missing preserve_quotes keyword argument (reported by M. Crusoe)

[0.12.3, 2016-08-17]:
- correct 'in' operation for merged CommentedMaps in round-trip mode 
  (implementation inspired by J.Ngo, but original not working for merges)
- iteration over round-trip loaded mappings, that contain merges. Also keys(), 
  items(), values() (Py3/Py2) and iterkeys(), iteritems(), itervalues(), 
  viewkeys(), viewitems(), viewvalues() (Py2)
- |-
  reuse of anchor name now generates warning, not an error. Round-tripping such
  anchors works correctly. This inherited PyYAML issue was brought to attention
  by G. Coddut (and was long standing https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=515634)
  suppressing the warning:
  ```
  import warnings
  from ruamel.yaml.error import ReusedAnchorWarning
  warnings.simplefilter("ignore", ReusedAnchorWarning)
  ```

[0.12.2, 2016-08-16]:
- minor improvements based on feedback from M. Crusoe 
  https://bitbucket.org/ruamel/yaml/issues/42/

[0.12.0, 2016-08-16]:
- drop support for Python 2.6
- include initial Type information (inspired by M. Crusoe)

[0.11.15, 2016-08-07]:
- Change to prevent FutureWarning in NumPy, as reported by tgehring ("comparison
  to None will result in an elementwise object comparison in the future")

[0.11.14, 2016-07-06]:
- fix preserve_quotes missing on original Loaders (as reported by Leynos, 
  bitbucket issue 38)

[0.11.13, 2016-07-06]:
- documentation only, automated linux wheels

[0.11.12, 2016-07-06]:
- |-
  added support for roundtrip of single/double quoted scalars using:
  ruamel.yaml.round_trip_load(stream, preserve_quotes=True)

[0.11.10, 2016-05-02]:
- added `.insert(pos, key, value, comment=None)` to CommentedMap

[0.11.10, 2016-04-19]:

- indent=2, block_seq_indent=2 works as expected

[0.11.0, 2016-02-18]:
- RoundTripLoader loads 1.2 by default (no sexagesimals, 012 octals nor 
  yes/no/on/off booleans

[0.10.11, 2015-09-17]:
- Fix issue 13: dependency on libyaml to be installed for yaml.h

[0.10.10, 2015-09-15]:
- Python 3.5 tested with tox
- pypy full test (old PyYAML tests failed on too many open file handles)

[0.10.6-0.10.9, 2015-09-14]:
- Fix for issue 9
- Fix for issue 11: double dump losing comments
- Include libyaml code
- move code from 'py' subdir for proper namespace packaging.

[0.10.5, 2015-08-25]:
- preservation of newlines after block scalars. Contributed by Sam Thursfield.

[0.10, 2015-06-22]:
- preservation of hand crafted anchor names ( not of the form "idNNN")
- preservation of map merges ( `<<` )

[0.9, 2015-04-18]:
- collections read in by the RoundTripLoader now have a `lc` property that can 
  be quired for line and column ( `lc.line` resp. `lc.col`)

[0.8, 2015-04-15]:
- bug fix for non-roundtrip save of ordereddict
- adding/replacing end of line comments on block style mappings/sequences

[0.7.2, 2015-03-29]:
- support for end-of-line comments on flow style sequences and mappings

[0.7.1, 2015-03-27]:
- RoundTrip capability of flow style sequences ( 'a: b, c, d' )

[0.7, 2015-03-26]:
- tests (currently failing) for inline sequece and non-standard spacing between 
  block sequence dash and scalar (Anthony Sottile)
- initial possibility (on list, i.e. CommentedSeq) to set the flow format 
  explicitly
- RoundTrip capability of flow style sequences ( 'a: b, c, d' )

[0.6.1, 2015-03-15]:
- setup.py changed so ruamel.ordereddict no longer is a dependency if not on 
  CPython 2.x (used to test only for 2.x, which breaks pypy 2.5.0 reported by 
  Anthony Sottile)

[0.6, 2015-03-11]:
- basic support for scalars with preserved newlines
- html option for yaml command
- check if yaml C library is available before trying to compile C extension
- include unreleased change in PyYAML dd 20141128

[0.5, 2015-01-14]:
- move configobj -> YAML generator to own module
- added dependency on ruamel.base (based on feedback from  Sess 
  <leycec@gmail.com>

[0.4, 2014-11-25]:
- move comment classes in own module comments
- fix omap pre comment
- make !!omap and !!set take parameters. There are still some restrictions:
  - no comments before the !!tag
- extra tests

[0.3, 2014-11-24]:
- fix value comment occuring as on previous line (looking like eol comment)
- INI conversion in yaml + tests
- (hidden) test in yaml for debugging with auto command
- fix for missing comment in middel of simple map + test

[0.2, 2014-11-23]:
- add ext/_yaml.c etc to the source tree
- tests for yaml to work on 2.6/3.3/3.4
- change install so that you can include ruamel.yaml instead of ruamel.yaml.py
- add "yaml" utility with initial subcommands (test rt, from json)

[0.1, 2014-11-22]:
- merge py2 and py3 code bases
- remove support for 2.5/3.0/3.1/3.2 (this merge relies on u"" as available in 
  3.3 and . imports not available in 2.5)
- tox.ini for 2.7/3.4/2.6/3.3
- remove lib3/ and tests/lib3 directories and content
- commit
- correct --verbose for test application
- DATA=changed to be relative to __file__ of code
- DATA using os.sep
- remove os.path from imports as os is already imported
- have test_yaml.py exit with value 0 on success, 1 on failures, 2 on error
- added support for octal integers starting with '0o' keep support for 01234 as 
  well as 0o1234
- commit
- |-
  added test_roundtrip_data:
  requires a .data file and .roundtrip (empty), yaml_load .data
  and compare dump against original.
- |-
  fix grammar as per David Pursehouse:
  https://bitbucket.org/xi/pyyaml/pull-request/5/fix-grammar-in-error-messages/diff
- http://www.json.org/ extra escaped char `\/` add .skip-ext as libyaml is not 
  updated
- |-
  David Fraser: Extract a method to represent keys in mappings, so that
  a subclass can choose not to quote them, used in repesent_mapping
  https://bitbucket.org/davidfraser/pyyaml/
- add CommentToken and percolate through parser and composer and constructor
- add Comments to wrapped mapping and sequence constructs (not to scalars)
- generate YAML with comments
- initial README
